Leetcode - Longest Palindromic Substring

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/chengyunyi123/article/details/77506739

Given a string s, find the longest palindromic substring in s. You may assume that the maximum length of s is 1000.

Example:

Input: “babad”
Output: “bab”
Note: “aba” is also a valid answer.
Example:
Input: “cbbd”
Output: “bb”


Solution


Approach #1 (Longest Common Substring) [Accepted]

Common mistake

Some people will be tempted to come up with a quick solution, which is unfortunately flawed (however can be corrected easily):

Reverse S and become S’.Find the longest common substring between S and S​′​​ , which must also be the longest palindromic substring.
This seemed to work, let’s see some examples below.

For example, S=”caba”,S​′=”abac”.

The longest common substring between S and S’ is ”aba”, which is the answer.

Let’s try another example:S=”abacdfgdcaba”,S’=”abacdgfdcaba”.

The longest common substring between S and S’
is ”abacd”. Clearly, this is not a valid palindrome.

Algorithm

We could see that the longest common substring method fails when there exists a reversed copy of a non-palindromic substring in some other part of SS. To rectify this, each time we find a longest common substring candidate, we check if the substring’s indices are the same as the reversed substring’s original indices. If it is, then we attempt to update the longest palindrome found so far; if not, we skip this and find the next candidate.

This gives us an O(n^2)Dynamic Programming solution which uses O(n^2) space (could be improved to use O(n) space). Please read more about Longest Common Substring here.

Approach #2 (Brute Force) [Time Limit Exceeded]

The obvious brute force solution is to pick all possible starting and ending positions for a substring, and verify if it is a palindrome.

Complexity Analysis

Time complexity : O(n^3).
Space complexity : O(1).

Approach #3 (Dynamic Programming) [Accepted]

To improve over the brute force solution, we first observe how we can avoid unnecessary re-computation while validating palindromes. Consider the case”ababa”. If we already knew that ”bab” is a palindrome, it is obvious that ”ababa” must be a palindrome since the two left and right end letters are the same.

We define P(i,j) as following:

P(i,j)={true,if the substring Si…Sj is a palindrome false,otherwise.
Therefore,

P(i,j)=(P(i+1,j−1) and S​i==S​j​​ )

The base cases are:

P(i, i) = true

P(i, i+1) = ( S_i == S_{i+1} )

This yields a straight forward DP solution, which we first initialize the one and two letters palindromes, and work our way up finding all three letters palindromes, and so on…

class Solution {
    private static boolean[][] dp;

    public String longestPalindrome(String s) {
        int len = s.length();

        if (s == null || len == 0) return "";

        dp = new boolean[len][len];
        int i, j;

        //初始化dp数组
        for (i = 0; i < len; i++) {
            for (j = 0; j < len; j++) {
                //当i == j 的时候,只有一个字符的字符串; 当 i > j 认为是空串,也是回文,其他情况都初始化成不是回文
                dp[i][j] = i >= j ? true : false;
            }
        }

        int k, maxLen = 1;
        int rf = 0, rt = 0;

        for (k = 1; k < len; k++) {
            for (i = 0; i + k < len; i++) {
                j = i + k;
                //对字符串 s[i....j] 如果 s[i] != s[j] 那么不是回文
                if (s.charAt(i) != s.charAt(j)) {
                    dp[i][j] = false;
                } else { //如果s[i] == s[j] 回文性质由 s[i+1][j-1] 决定
                    dp[i][j] = dp[i + 1][j - 1];
                    if (dp[i][j]) {
                        if (k + 1 > maxLen) {
                            maxLen = k + 1;
                            rf = i;
                            rt = j;
                        }
                    }
                }
            }
        }

        return s.substring(rf, rt + 1);
    }
}

Complexity Analysis

Time complexity : O(n^2).
Space complexity : O(n^2). It uses O(n^2) space to store the table.

Additional Exercise

Could you improve the above space complexity further and how?

Approach #4 (Expand Around Center) [Accepted]

In fact, we could solve it in O(n^2)time using only constant space.

We observe that a palindrome mirrors around its center. Therefore, a palindrome can be expanded from its center, and there are only 2n−1 such centers.

You might be asking why there are 2n−1 but not n centers? The reason is the center of a palindrome can be in between two letters. Such palindromes have even number of letters (such as ”abba”) and its center are between the two ’b’s.

public String longestPalindrome(String s) {
    int start = 0, end = 0;
    for (int i = 0; i < s.length(); i++) {
        int len1 = expandAroundCenter(s, i, i);
        int len2 = expandAroundCenter(s, i, i + 1);
        int len = Math.max(len1, len2);
        if (len > end - start) {
            start = i - (len - 1) / 2;
            end = i + len / 2;
        }
    }
    return s.substring(start, end + 1);
}

private int expandAroundCenter(String s, int left, int right) {
    int L = left, R = right;
    while (L >= 0 && R < s.length() && s.charAt(L) == s.charAt(R)) {
        L--;
        R++;
    }
    return R - L - 1;
}

Complexity Analysis

Time complexity : O(n^2). Since expanding a palindrome around its center could take O(n) time, the overall complexity is O(n^2).
Space complexity : O(1).

Approach #5 (Manacher’s Algorithm) [Accepted]

There is even an O(n) algorithm called Manacher’s algorithm, explained here in detail. However, it is a non-trivial algorithm, and no one expects you to come up with this algorithm in a 45 minutes coding session. But, please go ahead and understand it, I promise it will be a lot of fun.
大神的思路和代码实现


本文只是参考Leetcode

猜你喜欢

转载自blog.csdn.net/chengyunyi123/article/details/77506739